package betterwithmods.common.entity.ai.eat;

import betterwithmods.util.player.PlayerHelper;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.pathfinding.PathNavigateGround;

public class EntityAITempt extends EntityAIBase {
    private final EntityCreature temptedEntity;
    private final double speed;
    private final Ingredient temptIngredient;
    private final boolean scaredByPlayerMovement;

    private double targetX;
    private double targetY;
    private double targetZ;
    private double pitch;
    private double yaw;
    private EntityPlayer temptingPlayer;
    private int delayTemptCounter;
    private boolean isRunning;


    public EntityAITempt(EntityCreature temptedEntityIn, double speedIn, boolean scaredByPlayerMovementIn, Ingredient temptIngredient) {
        this.temptedEntity = temptedEntityIn;
        this.speed = speedIn;
        this.temptIngredient = temptIngredient;
        this.scaredByPlayerMovement = scaredByPlayerMovementIn;
        this.func_75248_a(3);

        if (!(temptedEntityIn.func_70661_as() instanceof PathNavigateGround)) {
            throw new IllegalArgumentException("Unsupported mob type for TemptGoal");
        }
    }

    public boolean func_75250_a() {
        if (this.delayTemptCounter > 0) {
            --this.delayTemptCounter;
            return false;
        } else {
            this.temptingPlayer = this.temptedEntity.field_70170_p.func_72890_a(this.temptedEntity, 10.0D);
            if (this.temptingPlayer == null) {
                return false;
            } else {
                return PlayerHelper.isHolding(this.temptingPlayer, this.temptIngredient);
            }
        }
    }

    public boolean func_75253_b() {
        if (this.scaredByPlayerMovement) {
            if (this.temptedEntity.func_70068_e(this.temptingPlayer) < 36.0D) {
                if (this.temptingPlayer.func_70092_e(this.targetX, this.targetY, this.targetZ) > 0.010000000000000002D) {
                    return false;
                }

                if (Math.abs((double) this.temptingPlayer.field_70125_A - this.pitch) > 5.0D || Math.abs((double) this.temptingPlayer.field_70177_z - this.yaw) > 5.0D) {
                    return false;
                }
            } else {
                this.targetX = this.temptingPlayer.field_70165_t;
                this.targetY = this.temptingPlayer.field_70163_u;
                this.targetZ = this.temptingPlayer.field_70161_v;
            }

            this.pitch = (double) this.temptingPlayer.field_70125_A;
            this.yaw = (double) this.temptingPlayer.field_70177_z;
        }

        return this.func_75250_a();
    }

    /**
     * Execute a one shot task or start executing a continuous task
     */
    public void func_75249_e() {
        this.targetX = this.temptingPlayer.field_70165_t;
        this.targetY = this.temptingPlayer.field_70163_u;
        this.targetZ = this.temptingPlayer.field_70161_v;
        this.isRunning = true;
    }

    /**
     * Reset the task's internal state. Called when this task is interrupted by another one
     */
    public void func_75251_c() {
        this.temptingPlayer = null;
        this.temptedEntity.func_70661_as().func_75499_g();
        this.delayTemptCounter = 100;
        this.isRunning = false;
    }

    /**
     * Keep ticking a continuous task that has already been started
     */
    public void func_75246_d() {
        this.temptedEntity.func_70671_ap().func_75651_a(this.temptingPlayer, (float) (this.temptedEntity.func_184649_cE() + 20), (float) this.temptedEntity.func_70646_bf());
        if (this.temptedEntity.func_70068_e(this.temptingPlayer) < 6.25D) {
            this.temptedEntity.func_70661_as().func_75499_g();
        } else {
            this.temptedEntity.func_70661_as().func_75497_a(this.temptingPlayer, this.speed);
        }
    }

    /**
     * @see #isRunning
     */
    public boolean isRunning() {
        return this.isRunning;
    }
}
