package betterwithmods.module.industry.pollution;

import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.math.ChunkPos;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;

import java.util.ArrayList;
import java.util.List;

public class CommandCheckPollution extends CommandBase {
    @Override
    public String func_71517_b() {
        return "checkPollution";
    }

    @Override
    public int func_82362_a() {
        return 2;
    }

    @Override
    public String func_71518_a(ICommandSender sender) {
        return "bwm.checkPollution.usage";
    }

    public void func_184881_a(MinecraftServer server, ICommandSender sender, String[] args) throws CommandException {
        World world = server.func_130014_f_();
        ChunkPos pos = new ChunkPos(sender.func_180425_c());
        Chunk chunk = world.func_72863_F().func_186026_b(pos.field_77276_a, pos.field_77275_b);
        if (chunk != null && chunk.func_177410_o()) {
            List<String> information = new ArrayList<>();
            providePollutionInformation(information, world, pos);
            for (int x = -1; x < 2; x++) {
                for (int z = -1; z < 2; z++) {
                    if (x * x != z * z) {
                        Chunk ch = world.func_72863_F().func_186026_b(pos.field_77276_a + x, pos.field_77275_b + z);
                        if (ch != null && ch.func_177410_o()) {
                            providePollutionInformation(information, world, ch.func_76632_l());
                        }
                    }
                }
            }
            if (!information.isEmpty())
                information.forEach(s -> sender.func_145747_a(new TextComponentString(s)));
            else sender.func_145747_a(new TextComponentString("Pollution data for chunk [" + pos.field_77276_a + ", " + pos.field_77275_b + "] somehow empty."));
        }
    }

    private void providePollutionInformation(List<String> addTo, World world, ChunkPos from) {
        float pollution = Pollution.handler.getPollutionStat(world, from);
        if (pollution > -1) {
            String info = "Chunk [" + from.field_77276_a + ", " + from.field_77275_b + "] pollution: " + String.format("%.2f", pollution) + " Leaf count: " + Pollution.handler.getLeafStat(world, from);
            addTo.add(info);
        }
    }
}
